
Global gx=800
Global gy=600
Global diff:Float = 1.0'0 bis 1, 0=extrem leicht, 1=extrem schwer
Global Version:String = "1.1"
AppTitle = "GeneralWorldfightSimulator "+Version


Graphics gx,gy,0
SeedRnd MilliSecs()
SetBlend ALPHABLEND

Global Round:Int=1
Global GameEnd
Global logo=LoadImage("gfx\logo.png")
MidHandleImage logo
Global bgimg=LoadImage("gfx\bg.png")
Global pimg:TImage[3]
Global action$[10]



For i=0 To 2
	pimg[i]=LoadImage("gfx\planet"+(i+1)+".png")
Next


Repeat
Cls
	DrawImage logo,gx/2,gy/2
	t:String = "[S]ingle or [H]ot Seat?"
	DrawText t,(gx-TextWidth(t))/2,2*gy/3
	If KeyHit(KEY_ESCAPE) End
	If KeyHit(KEY_S) c=TP.Create(2)
	If KeyHit(KEY_H) c=TP.Create(1)
Flip
Until c

Global m:TMap = New TMap

Repeat
Cls
	SetColor 100,100,100
	TileImage bgimg,0,0
	tp.p[tp.cp].logic()

	TP.Setc(TP.cp+1)
	SetAlpha 0.5
	m.DrawPos(m.Getc(0),m.Getc(1))
	SetAlpha 1
	m.Draw()
	
	If KeyHit(KEY_ESCAPE) End
Flip
Until GameEnd

Cls

For i=0 To 1
	If Not TP.p[i].lost
		t:String = TP.p[i].name+" gewinnt!"
		
	Else
		t:String = TP.p[i].name+" verliert!"
	EndIf
	t:+"  Kills: "+TP.p[i].kills
	TP.setc(i+1)
	DrawText t,(gx-TextWidth(t))/2,10+i*15
Next
SetColor 255,255,255
t:String = "Runden: "+Round
DrawText t,(gx-TextWidth(t))/2,55
Flip
WaitKey()
End



Function NextTurn()
	If TP.p[TP.cp].planets=0
		TP.p[TP.cp].lost=True
		GameEnd = True
	EndIf
	tp.cp:+1
	tp.cp:Mod 2
	If tp.cp=0 m.nextround()
End Function

Type TF
	Field nr
	Field player
	Field s
	Field x,y
	Field r
		
	Method Draw(x,y:Int Ptr, sel=0)
		If TP.cp=player-1 And sel
			SetAlpha 0.5
			DrawRect x-5,y[0]-2,110,50
			m.drawCircle(Self.x,Self.y,d()+1)
		ElseIf Not TP.cp=player-1
			SetAlpha 0.2
			m.drawCircle(Self.x,Self.y,d()+1)
		EndIf
		
		SetAlpha 1
		DrawText "Fleet No. "+(nr+1) ,x,y[0];y[0]:+15
		DrawText "Ships: "+s, x,y[0]  ; y[0]:+15
		DrawText "Distance: "+d(), x,y[0]  ; y[0]:+15
		y[0]:+15
	End Method
	
	Method d()
		Return Round-r
	End Method
	
	Method Load()
		m.d[x,y,2]:-1
		s:+1
		Return 1
	End Method
	
	Method Unload(x2,y2)
		If Not m.InC(x,y,d()+1,x2,y2) Return
		p$ = "["+(x2+1)+"|"+(y2+1)+"]"
		
		If m.d[x2,y2,1]=player
			m.d[x2,y2,2]:+s
		Else'fight
			If m.d[x2,y2,2]<s
				If m.d[x2,y2,2]
					addAct(TP.p[player-1].name+" erobert Planeten "+p)
					TP.p[player-1].kills:+m.d[x2,y2,2]
				Else
					addAct(TP.p[player-1].name+" besiedelt Planeten "+p)
				EndIf
				m.d[x2,y2,2]=s
				m.d[x2,y2,1]=player
			Else
				addAct(TP.p[player].name+" verliert "+s+" Einheiten im Kampf")
			EndIf
		EndIf
		
		m.d[x2,y2,3]=0'keine Starterlaubnis

		TP.p[player-1].fleet[nr]=Null
		TP.p[player-1].SelectFleet(0,0,1)
		m.CalcRess()
	End Method

End Type


Type TP
	Global cp
	Global p:TP[2]
	Field name:String
	Field ki, kiaggr
	Field nr,newunits,state
	Field fleet:TF[9],cf
	Field ress[3], planets
	Field lost
	Field kills
	
	Function Create(n:Int)
		For i=0 To 1
			p[i] = New TP
			p[i].name = "Player "+(i+1)
			If (n=2 And i) p[i].ki=1
			If  p[i].ki 
				p[i].kiaggr = Rand(60*diff,100*diff)
				DebugLog "KI Aggr: "+p[i].kiaggr
			EndIf
			p[i].nr = i+1
		Next
		Return 1
	End Function
	
	Method SelectFleet:TF(x,y,any=False)
		For i=0 To  8
			If fleet[i]
				If any
					cf = fleet[i].nr
					Return fleet[i]
				EndIf
				If fleet[i].x=x And fleet[i].y=y And Not fleet[i].d() Return fleet[i]
			EndIf
		Next
	End Method
	
	Method logic()
		If Self.ki
			runki()
			NextTurn()
			Return
		EndIf
		If newunits And (TP.p[TP.cp].ress[0] Or TP.p[TP.cp].ress[1] Or TP.p[TP.cp].ress[2])
			state=0
		Else
			state = 1
		EndIf
		setc(nr)
		DrawText name,10,10
		DrawText "new: "+newunits+" Ress["+ress[0]+"|"+ress[1]+"|"+ress[2]+"]",10,25
		
		If KeyHit(KEY_ENTER)
			NextTurn()
			Return
		EndIf
			
		'Flotte auswhlen
		For i=49 To 57
			If KeyHit(i) cf = (i-49)
		Next
		
		Select state
			Case 0
				DrawText "Aufstellen",10,50
				If MouseHit(1) placeunit(m.getc(0),m.getc(1))
				FlushMouse()
				If newunits=0 state=1
			Case 1 DrawText "Flottenbefehle",10,50
				'Flotte erstellen, aufrsten				
				If MouseHit(1)
					AddFleet(m.getc(0),m.getc(1))
				EndIf
				
				If MouseHit(2)
					If fleet[cf] fleet[cf].Unload(m.getc(0),m.getc(1))
				EndIf
				FlushMouse()
		End Select
		
		DrawFleets(10)
		TP.p[Not (nr-1)].DrawFleets(gx-120)
		DrawText "Feindliche Flotten:",gx-160,50
	End Method
	
	Method runki()
		DebugLog "KI State: "+state
		DebugLog "planets: "+planets
		If planets>0'Wenn berhaupt startplaneten vorhanden sind
		If state=0'siedlungsphase
			If planets>4 state=1
			While newunits
				For x2=0 Until m.m
				For y2=0 Until m.m
					placeunit(x2,y2)
					AddFleet(x2,y2)
				Next
				Next
			Wend
				
			For x2=0 Until m.m
			For y2=0 Until m.m
				AddFleet(x2,y2)
			Next
			Next
		ElseIf state=1
			If planets>10 state=2
			If Rand(0,100)<kiaggr
				DebugLog "Attack"
				For x2=0 Until m.m
				For y2=0 Until m.m
					If m.d[x2,y2,1]=nr
						While newunits
							placeunit(x2,y2)
						Wend
						kistart(x2,y2)
					EndIf
				Next
				Next
			Else
				Local Minim=2
				DebugLog "Defense"
				Repeat
					For x2=0 Until m.m
					For y2=0 Until m.m
						If m.d[x2,y2,1]=nr
							If m.d[x2,y2,2]<minim
								Local ok=0
								If m.d[x2,y2,0]=3 And Not Rand(0,1) ok=1
								If (m.d[x2,y2,0]=2 Or m.d[x2,y2,0]=1) And Not Rand(0,2) ok=1
								If ok
									While newunits
										placeunit(x2,y2)
									Wend
									minim=0
								EndIf
							EndIf
						EndIf
					Next
					Next
					If minim minim:+1
				Until minim=0
			EndIf
		ElseIf state=2'Brutal Mass Attack
			If planets<10 state=1
				
			For x2=0 Until m.m
			For y2=0 Until m.m
				If m.d[x2,y2,1]=nr
					While newunits
						placeunit(x2,y2)
					Wend
					If m.d[x2,y2,2]-2>getben()
						DebugLog "KI create big army"
						kistart(x2,y2)
					EndIf
				EndIf
			Next
			Next
		EndIf
		EndIf
		
		For i=0 To  8
			e=0
			For x2=0 Until m.m
			For y2=0 Until m.m
				If m.d[x2,y2,1]<>nr And m.d[x2,y2,0] And fleet[i]
					If m.InC(fleet[i].x,fleet[i].y,fleet[i].d()+1 ,x2,y2)
						If fleet[i].s>3 And state=2 And fleet[i].d()<Sqr(m.m^2)
							If (fleet[i].s-m.d[x2,y2,2])>(fleet[i].s/4)'Nur wenn auch genug kaputt gemacht werden
								DebugLog "Attack with big army"
								fleet[i].Unload(x2,y2)
								e=1
							EndIf
						ElseIf m.d[x2,y2,2]<fleet[i].s
							If m.d[x2,y2,0]=3
								DebugLog "Attack big planet"
								fleet[i].Unload(x2,y2)
								e=1
							ElseIf m.d[x2,y2,0]=2 Or m.d[x2,y2,0]=1
								DebugLog "Attack small planet"
								If Not Rand(0,2) fleet[i].Unload(x2,y2);e=1
							EndIf
						EndIf
					EndIf
				EndIf
				If e Continue
			Next
			If e Continue
			Next
		Next
	End Method
	
	Method kistart(x,y)
		While m.d[x,y,2]>1
			AddFleet(x,y)
		Wend
	End Method
	
	Method getben()'GetAverage Army strength
		For x2=0 Until m.m
		For y2=0 Until m.m
			If m.d[x2,y2,1]<>nr
				c:+1
				b:+m.d[x2,y2,2]
			EndIf
		Next
		Next
		If c Return b/c
	End Method
	
	Method DrawFleets(x)
		setc(nr)
		ypos=70
		For i=0 To  8
			If fleet[i] fleet[i].Draw(x,Varptr ypos,cf=i)
		Next
	End Method
	
	Method AddFleet(x,y)
		If (m.d[x,y,1]<>nr) Or m.d[x,y,2]<=1 Or m.d[x,y,3]=0 Return
		f:TF = SelectFleet(x,y)
		If Not f f=NewFleet(x,y)
		If Not f Return
		f.Load()
	End Method
	
	Method NewFleet:TF(x,y)
		For i=0 To  8
			If fleet[i]=Null
				fleet[i]=New TF
				cf=i
				fleet[i].nr = i
				fleet[i].x=x
				fleet[i].y=y
				fleet[i].r = Round
				fleet[i].player = Self.nr
				Return fleet[i]
			EndIf
		Next
	End Method
	
	Method placeunit(x,y)
		If m.d[x,y,1]=nr And newunits>0
			m.d[x,y,2]:+1
			newunits:-1
		EndIf
	End Method
	
	Method AddRess()
		n=ress[2] + (ress[0]+ress[1]-Abs(ress[0]-ress[1]))/2
		If Not ki AddAct(name+" erhaelt "+n+ " Einheiten")
		Self.newunits:+ n
	End Method
	
	Function setc(nr)
		Select nr
			Case 0 SetColor 200,200,200
			Case 1 SetColor 0,150,255
			Case 2 SetColor 255,50,50
		End Select
	End Function
			

End Type



Type TMap
	Field d:Int[10,10,4]'0=Planet(0=Planet(1=+,2=-,3=o),1=Besitzer,2=Armee,3=starterlaubnis)
	Field s = 40, m =9
	Field ox = (gx-s*m)/2,oy = (gy-s*m)/2
	
	Method New()
		For i=0 Until m*m
			If Not(i Mod 2) d[i Mod m,i/m,0]=Rand(1,3)
			d[i Mod m,i/m,3]=1
		Next
		t=m-1
		d[0,0,2]=2
		d[0,0,1]=1
		d[0,0,0]=3
		d[t,t,2]=2
		d[t,t,1]=2
		d[t,t,0]=3
		CalcRess()
	End Method
	
	Method Getc(a)
		Local c
		If a
			c = (MouseY()-oy)/s
		Else
			c = (MouseX()-ox)/s
		EndIf
		If c<0 c = 0
		If c>(m-1) c = m-1
		Return c
	End Method
	
	Method DrawPos(x,y)
		If x<0 Or x>m-1 Or y<0 Or y>m-1 Return
		DrawRect x*s+ox+1,y*s+oy+1,s-2,s-2
	End Method
	
	Method DrawCircle(x,y,r)
		For x2=0 Until m
		For y2=0 Until m
			If InC(x,y,r,x2,y2)
				DrawPos(x2,y2)
			EndIf
		Next
		Next
	End Method
	
	Method InC(x,y,r,x2,y2)
		If x2<0 Or x2>m-1 Or y2<0 Or y2>m-1 Return 0
		Return Sqr((x-x2)^2+(y-y2)^2)<r
	End Method

	
	Method Draw()
		For x=0 Until m
			x0=x*s+ox
			SetColor 200,200,200
			DrawText (x+1),x0+s/2,oy-s/2
		For y=0 Until m
			y0=y*s+oy
			
			SetColor 200,200,200
			DrawText (y+1),ox-s/2,y0+s/2
			
			SetColor 255,255,255
			DrawRect x0,y0,s,1
			DrawRect x0,y0,1,s
			DrawRect x0,y0+s,s,1
			DrawRect x0+s,y0,1,s
			p=d[x,y,0]
			If p
				DrawImage pimg[d[x,y,0]-1],x0,y0
				If d[x,y,2]>0
					SetColor 0,0,0
					SetAlpha 0.5
					DrawOval x0,y0+s/4,s,s/2
					SetAlpha 1
					DrawText d[x,y,2],x0+15,y0+15
					TP.Setc(d[x,y,1])
					DrawText d[x,y,2],x0+14,y0+14
				EndIf
			EndIf
		Next
		Next
		y0:+s+2
		SetColor 200,200,200
		For i=0 Until action.length
			t:String = action[i]
			DrawText t,(gx-TextWidth(t))/2,y0+15*i
		Next
	End Method
	
	Method Nextround()
		Round:+1
		For x=0 Until m
		For y=0 Until m
			d[x,y,3]=1'Starterlaubnis setzen
		Next
		Next
		If Round Mod 2 DealUnits()
	End Method
	
	Method CalcRess()
		For i=0 To 2
			TP.p[0].ress[i]=0
			TP.p[1].ress[i]=0
		Next
			
		For x=0 Until m
		For y=0 Until m
			p=d[x,y,1]
			If p
				DebugLog p
				TP.p[p-1].ress[d[x,y,0]-1]:+1
			EndIf
		Next
		Next
		For i=0 To 1
			TP.p[i].planets = TP.p[i].ress[0] + TP.p[i].ress[1] + TP.p[i].ress[2]
		Next
	End Method
	
	Method DealUnits()
		CalcRess()
		For i=0 To 1
			TP.p[i].AddRess()
		Next
	End Method
End Type

Function addAct(t$)'Adds an output action
	For i=action.length-2 To 0 Step -1
		action[i+1] = action[i]
	Next
	action[0]=t
End Function
